Package net.sf.saxon.expr.instruct

## Class ForEach

- java.lang.Object
- - net.sf.saxon.expr.Expression
  - - net.sf.saxon.expr.instruct.Instruction
    - - net.sf.saxon.expr.instruct.ForEach

- All Implemented Interfaces:
    `ContextMappingFunction`, `ContextOriginator`, `ContextSwitchingExpression`, `ExportAgent`, `TailCallReturner`, `Locatable`, `IdentityComparable`, `Traceable`
  Direct Known Subclasses:
    `MultithreadedForEach`

      public class ForEach
      extends Instruction
      implements ContextMappingFunction, ContextSwitchingExpression

  Handler for xsl:for-each elements in a stylesheet. The same class handles the "!" operator in XPath 3.0, which has identical semantics to xsl:for-each, and it is used to support the "/" operator in cases where it is known that the rhs delivers atomic values.

- - ### Field Summary

    Fields
    Modifier and Type | Field | Description
    --- | --- | ---
    `protected Operand` | `actionOp` |
    `protected boolean` | `containsTailCall` |
    `protected boolean` | `isInstruction` |
    `protected Operand` | `selectOp` |
    `protected Operand` | `separatorOp` |
    `protected Operand` | `threadsOp` |

    - ### Fields inherited from class net.sf.saxon.expr.Expression

      `EFFECTIVE_BOOLEAN_VALUE, EVALUATE_METHOD, ITEM_FEED_METHOD, ITERATE_METHOD, MAX_COST, MAX_SEQUENCE_LENGTH, MAX_STRING_LENGTH, PROCESS_METHOD, staticProperties, UNBOUNDED_LOWER, UNBOUNDED_UPPER, UPDATE_METHOD, WATCH_METHOD`

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `ForEach​(Expression select, Expression action)` | Create an xsl:for-each instruction
    `ForEach​(Expression select, Expression action, boolean containsTailCall, Expression threads)` | Create an xsl:for-each instruction

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `PathMap.PathMapNodeSet` | `addToPathMap​(PathMap pathMap, PathMap.PathMapNodeSet pathMapNodeSet)` | Add a representation of this expression to a PathMap.
    `boolean` | `alwaysCreatesNewNodes()` | Ask whether it is guaranteed that every item in the result of this instruction is a newly created node.
    `void` | `checkForUpdatingSubexpressions()` | Check to ensure that this expression does not contain any inappropriate updating subexpressions.
    `void` | `checkPermittedContents​(SchemaType parentType, boolean whole)` | Check that any elements and attributes constructed or returned by this expression are acceptable in the content model of a given complex type.
    `int` | `computeSpecialProperties()` | Get the static properties of this expression (other than its type).
    `Expression` | `copy​(RebindingMap rebindings)` | Copy an expression.
    `void` | `evaluatePendingUpdates​(XPathContext context, PendingUpdateList pul)` | Evaluate an updating expression, adding the results to a Pending Update List.
    `protected void` | `explainThreads​(ExpressionPresenter out)` |
    `void` | `export​(ExpressionPresenter out)` | Diagnostic print of expression structure.
    `Expression` | `getAction()` | Get the action expression (in XSLT, the body of the xsl:for-each instruction
    `Expression` | `getActionExpression()` | Get the subexpression that is evaluated in the new context
    `java.lang.String` | `getExpressionName()` | Get a name identifying the kind of expression, in terms meaningful to a user.
    `int` | `getImplementationMethod()` | An implementation of Expression must provide at least one of the methods evaluateItem(), iterate(), or process().
    `int` | `getInstructionNameCode()` | Get the name of this instruction for diagnostic and tracing purposes
    `ItemType` | `getItemType()` | Determine the data type of the items returned by this expression
    `Expression` | `getNumberOfThreadsExpression()` | Get the number of threads requested
    `Expression` | `getSelect()` | Get the select expression
    `Expression` | `getSelectExpression()` | Get the select expression
    `Expression` | `getSeparatorExpression()` |
    `UType` | `getStaticUType​(UType contextItemType)` | Get the static type of the expression as a UType, following precisely the type inference rules defined in the XSLT 3.0 specification.
    `java.lang.String` | `getStreamerName()` | Get the (partial) name of a class that supports streaming of this kind of expression
    `Expression` | `getThreads()` | Get the expression used to determine how many threads to use when multi-threading
    `boolean` | `isInstruction()` | Ask whether this expression is an instruction.
    `boolean` | `isUpdatingExpression()` | Determine whether this is an updating expression as defined in the XQuery update specification
    `SequenceIterator` | `iterate​(XPathContext context)` | Return an Iterator to iterate over the values of the sequence.
    `protected NodeInfo` | `makeSeparator​(XPathContext context)` |
    `SequenceIterator` | `map​(XPathContext context)` | Map one item to a sequence.
    `boolean` | `mayCreateNewNodes()` | Determine whether this instruction creates new nodes.
    `java.lang.Iterable<Operand>` | `operands()` | Get the operands of this expression
    `Expression` | `optimize​(ExpressionVisitor visitor, ContextItemStaticInfo contextInfo)` | Perform optimisation of an expression and its subexpressions.
    `TailCall` | `processLeavingTail​(Outputter output, XPathContext context)` | ProcessLeavingTail: called to do the real work of this instruction.
    `void` | `setAction​(Expression action)` | Set the action expression (in XSLT, the body of the xsl:for-each instruction)
    `void` | `setActionExpression​(Expression action)` | Set the action expression
    `void` | `setInstruction​(boolean inst)` | Say whether this ForEach expression originates as an XSLT instruction
    `void` | `setSelect​(Expression select)` | Set the select expression
    `void` | `setSelectExpression​(Expression select)` | Set the select expression
    `void` | `setSeparatorExpression​(Expression separator)` | Set the separator expression (Saxon extension)
    `void` | `setThreads​(Expression threads)` | Set the expression used to determine how many threads to use when multi-threading
    `java.lang.String` | `toShortString()` | Produce a short string identifying the expression for use in error messages
    `java.lang.String` | `toString()` | The toString() method for an expression attempts to give a representation of the expression in an XPath-like form.
    `Expression` | `typeCheck​(ExpressionVisitor visitor, ContextItemStaticInfo contextInfo)` | Perform type checking of an expression and its subexpressions.
    `Expression` | `unordered​(boolean retainAllNodes, boolean forStreaming)` | Replace this expression by a simpler expression that delivers the results without regard to order.

    - ### Methods inherited from class net.sf.saxon.expr.instruct.Instruction

      `assembleParams, assembleTunnelParams, computeCardinality, dynamicError, evaluateAsString, evaluateItem, getNetCost, getSourceLocator, isXSLT, process, someOperandCreatesNewNodes`

    - ### Methods inherited from class net.sf.saxon.expr.Expression

      `adoptChildExpression, allowExtractingCommonSubexpressions, checkedOperands, computeDependencies, computeHashCode, computeStaticProperties, dynamicError, effectiveBooleanValue, equals, explain, getCardinality, getConfiguration, getCost, getDependencies, getEvaluationMethod, getExtraProperty, getIntegerBounds, getInterpretedExpression, getIntrinsicDependencies, getLocalRetainedStaticContext, getLocation, getObjectName, getPackageData, getParentExpression, getProperties, getProperty, getRetainedStaticContext, getScopingExpression, getSlotsUsed, getSpecialProperties, getStaticBaseURI, getStaticBaseURIString, getStaticType, getTracingTag, hasCompatibleStaticContext, hashCode, hasSpecialProperty, hasVariableBinding, identityHashCode, implementsStaticTypeCheck, isCallOn, isEqual, isIdentical, isLiftable, isMultiThreaded, isStaticPropertiesKnown, isSubtreeExpression, isVacuousExpression, markTailFunctionCalls, operandList, operandSparseList, optimizeChildren, prepareForStreaming, resetLocalStaticProperties, restoreParentPointers, setEvaluationMethod, setExtraProperty, setFiltered, setFlattened, setLocation, setParentExpression, setRetainedStaticContext, setRetainedStaticContextLocally, setRetainedStaticContextThoroughly, setStaticProperty, simplify, simplifyChildren, staticTypeCheck, suppressValidation, toPattern, typeCheckChildren, typeError, verifyParentPointers`

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface net.sf.saxon.trace.Traceable

      `gatherProperties`

- - ### Field Detail

    - #### containsTailCall

          protected boolean containsTailCall

    - #### selectOp

          protected Operand selectOp

    - #### actionOp

          protected Operand actionOp

    - #### separatorOp

          protected Operand separatorOp

    - #### threadsOp

          protected Operand threadsOp

    - #### isInstruction

          protected boolean isInstruction

  - ### Constructor Detail

    - #### ForEach

          public ForEach​(Expression select,
                         Expression action)

      Create an xsl:for-each instruction
      Parameters:
        `select` - the select expression
        `action` - the body of the xsl:for-each loop

    - #### ForEach

          public ForEach​(Expression select,
                         Expression action,
                         boolean containsTailCall,
                         Expression threads)

      Create an xsl:for-each instruction
      Parameters:
        `select` - the select expression
        `action` - the body of the xsl:for-each loop
        `containsTailCall` - true if the body of the loop contains a tail call on the containing function
        `threads` - if >1 causes multithreaded execution (Saxon-EE only)

  - ### Method Detail

    - #### setSeparatorExpression

          public void setSeparatorExpression​(Expression separator)

      Set the separator expression (Saxon extension)

    - #### getSeparatorExpression

          public Expression getSeparatorExpression()

    - #### setInstruction

          public void setInstruction​(boolean inst)

      Say whether this ForEach expression originates as an XSLT instruction
      Parameters:
        `inst` - true if this is an xsl:for-each instruction; false if it is the XPath "!" operator

    - #### isInstruction

          public boolean isInstruction()

      Ask whether this expression is an instruction. In XSLT streamability analysis this is used to distinguish constructs corresponding to XSLT instructions from other constructs.
      Overrides:
        `isInstruction` in class `Instruction`
      Returns:
        true if this construct originates as an XSLT instruction

    - #### getSelect

          public Expression getSelect()

      Get the select expression
      Returns:
        the select expression. Note this will have been wrapped in a sort expression if sorting was requested.

    - #### setSelect

          public void setSelect​(Expression select)

      Set the select expression
      Parameters:
        `select` - the select expression of the for-each

    - #### getAction

          public Expression getAction()

      Get the action expression (in XSLT, the body of the xsl:for-each instruction
      Returns:
        the action expression

    - #### setAction

          public void setAction​(Expression action)

      Set the action expression (in XSLT, the body of the xsl:for-each instruction)
      Parameters:
        `action` - the action expression

    - #### getThreads

          public Expression getThreads()

      Get the expression used to determine how many threads to use when multi-threading
      Returns:
        the saxon:threads expression if present, or null otherwise

    - #### setThreads

          public void setThreads​(Expression threads)

      Set the expression used to determine how many threads to use when multi-threading
      Parameters:
        `threads` - the saxon:threads expression if present, or null otherwise

    - #### operands

          public java.lang.Iterable<Operand> operands()

      Get the operands of this expression
      Specified by:
        `operands` in class `Instruction`
      Returns:
        the operands

    - #### getInstructionNameCode

          public int getInstructionNameCode()

      Get the name of this instruction for diagnostic and tracing purposes
      Overrides:
        `getInstructionNameCode` in class `Instruction`
      Returns:
        the code for name xsl:for-each

    - #### getSelectExpression

          public Expression getSelectExpression()

      Get the select expression
      Specified by:
        `getSelectExpression` in interface `ContextSwitchingExpression`
      Returns:
        the select expression. Note this will have been wrapped in a sort expression if sorting was requested.

    - #### setSelectExpression

          public void setSelectExpression​(Expression select)

      Set the select expression
      Parameters:
        `select` - the select expression

    - #### setActionExpression

          public void setActionExpression​(Expression action)

      Set the action expression
      Parameters:
        `action` - the select expression

    - #### getActionExpression

          public Expression getActionExpression()

      Get the subexpression that is evaluated in the new context
      Specified by:
        `getActionExpression` in interface `ContextSwitchingExpression`
      Returns:
        the subexpression evaluated in the context set by the controlling expression

    - #### getNumberOfThreadsExpression

          public Expression getNumberOfThreadsExpression()

      Get the number of threads requested
      Returns:
        the value of the saxon:threads attribute

    - #### getItemType

          public final ItemType getItemType()

      Determine the data type of the items returned by this expression
      Overrides:
        `getItemType` in class `Instruction`
      Returns:
        the data type

    - #### getStaticUType

          public UType getStaticUType​(UType contextItemType)

      Get the static type of the expression as a UType, following precisely the type inference rules defined in the XSLT 3.0 specification.
      Overrides:
        `getStaticUType` in class `Expression`
      Parameters:
        `contextItemType` - static type of the context item
      Returns:
        the static item type of the expression according to the XSLT 3.0 defined rules

    - #### mayCreateNewNodes

          public final boolean mayCreateNewNodes()

      Determine whether this instruction creates new nodes. This implementation returns true if the "action" creates new nodes. (Nodes created by the condition can't contribute to the result).
      Overrides:
        `mayCreateNewNodes` in class `Instruction`
      Returns:
        true if the instruction creates new nodes under some input conditions (or if it can't be proved that it doesn't)

    - #### typeCheck

          public Expression typeCheck​(ExpressionVisitor visitor,
                                      ContextItemStaticInfo contextInfo)
                               throws XPathException

      Description copied from class: `Expression`
      Perform type checking of an expression and its subexpressions. This is the second phase of static optimization.

      This checks statically that the operands of the expression have the correct type; if necessary it generates code to do run-time type checking or type conversion. A static type error is reported only if execution cannot possibly succeed, that is, if a run-time type error is inevitable. The call may return a modified form of the expression.

      This method is called after all references to functions and variables have been resolved to the declaration of the function or variable. However, the types of such functions and variables may not be accurately known if they have not been explicitly declared.

      Overrides:
        `typeCheck` in class `Expression`
      Parameters:
        `visitor` - an expression visitor
        `contextInfo` - Information available statically about the context item: whether it is (possibly) absent; its static type; its streaming posture.
      Returns:
        the original expression, rewritten to perform necessary run-time type checks, and to perform other type-related optimizations
      Throws:
        `XPathException` - if an error is discovered during this phase (typically a type error)

    - #### optimize

          public Expression optimize​(ExpressionVisitor visitor,
                                     ContextItemStaticInfo contextInfo)
                              throws XPathException

      Description copied from class: `Expression`
      Perform optimisation of an expression and its subexpressions. This is the third and final phase of static optimization.

      This method is called after all references to functions and variables have been resolved to the declaration of the function or variable, and after all type checking has been done.

      Overrides:
        `optimize` in class `Expression`
      Parameters:
        `visitor` - an expression visitor
        `contextInfo` - the static type of "." at the point where this expression is invoked. The parameter is set to null if it is known statically that the context item will be undefined. If the type of the context item is not known statically, the argument is set to `Type.ITEM_TYPE`
      Returns:
        the original expression, rewritten if appropriate to optimize execution
      Throws:
        `XPathException` - if an error is discovered during this phase (typically a type error)

    - #### unordered

          public Expression unordered​(boolean retainAllNodes,
                                      boolean forStreaming)
                               throws XPathException

      Replace this expression by a simpler expression that delivers the results without regard to order.
      Overrides:
        `unordered` in class `Expression`
      Parameters:
        `retainAllNodes` - set to true if the result must contain exactly the same nodes as the original; set to false if the result can eliminate (or introduce) duplicates.
        `forStreaming` - set to true if optimizing for streaming
      Returns:
        an expression that delivers the same nodes in a more convenient order
      Throws:
        `XPathException` - if the rewrite fails

    - #### addToPathMap

          public PathMap.PathMapNodeSet addToPathMap​(PathMap pathMap,
                                                     PathMap.PathMapNodeSet pathMapNodeSet)

      Add a representation of this expression to a PathMap. The PathMap captures a map of the nodes visited by an expression in a source tree.

      The default implementation of this method assumes that an expression does no navigation other than the navigation done by evaluating its subexpressions, and that the subexpressions are evaluated in the same context as the containing expression. The method must be overridden for any expression where these assumptions do not hold. For example, implementations exist for AxisExpression, ParentExpression, and RootExpression (because they perform navigation), and for the doc(), document(), and collection() functions because they create a new navigation root. Implementations also exist for PathExpression and FilterExpression because they have subexpressions that are evaluated in a different context from the calling expression.

      Overrides:
        `addToPathMap` in class `Expression`
      Parameters:
        `pathMap` - the PathMap to which the expression should be added
        `pathMapNodeSet` - the set of nodes in the path map that are affected
      Returns:
        the pathMapNode representing the focus established by this expression, in the case where this expression is the first operand of a path expression or filter expression. For an expression that does navigation, it represents the end of the arc in the path map that describes the navigation route. For other expressions, it is the same as the input pathMapNode.

    - #### copy

          public Expression copy​(RebindingMap rebindings)

      Copy an expression. This makes a deep copy.
      Specified by:
        `copy` in class `Expression`
      Parameters:
        `rebindings` - variables that need to be re-bound
      Returns:
        the copy of the original expression

    - #### computeSpecialProperties

          public int computeSpecialProperties()

      Get the static properties of this expression (other than its type). The result is bit-signficant. These properties are used for optimizations. In general, if property bit is set, it is true, but if it is unset, the value is unknown.
      Overrides:
        `computeSpecialProperties` in class `Instruction`
      Returns:
        a set of flags indicating static properties of this expression

    - #### alwaysCreatesNewNodes

          public boolean alwaysCreatesNewNodes()

      Description copied from class: `Instruction`
      Ask whether it is guaranteed that every item in the result of this instruction is a newly created node.
      Overrides:
        `alwaysCreatesNewNodes` in class `Instruction`
      Returns:
        true if result of the instruction is always either an empty sequence or a sequence consisting entirely of newly created nodes

    - #### isUpdatingExpression

          public boolean isUpdatingExpression()

      Determine whether this is an updating expression as defined in the XQuery update specification
      Overrides:
        `isUpdatingExpression` in class `Expression`
      Returns:
        true if this is an updating expression

    - #### checkForUpdatingSubexpressions

          public void checkForUpdatingSubexpressions()
                                              throws XPathException

      Check to ensure that this expression does not contain any inappropriate updating subexpressions. This check is overridden for those expressions that permit updating subexpressions.
      Overrides:
        `checkForUpdatingSubexpressions` in class `Expression`
      Throws:
        `XPathException` - if the expression has a non-permitted updating subexpression

    - #### getImplementationMethod

          public int getImplementationMethod()

      An implementation of Expression must provide at least one of the methods evaluateItem(), iterate(), or process(). This method indicates which of these methods is provided. This implementation provides both iterate() and process() methods natively.
      Overrides:
        `getImplementationMethod` in class `Instruction`
      Returns:
        the implementation method, for example `Expression.ITERATE_METHOD` or `Expression.EVALUATE_METHOD` or `Expression.PROCESS_METHOD`

    - #### checkPermittedContents

          public void checkPermittedContents​(SchemaType parentType,
                                             boolean whole)
                                      throws XPathException

      Check that any elements and attributes constructed or returned by this expression are acceptable in the content model of a given complex type. It's always OK to say yes, since the check will be repeated at run-time. The process of checking element and attribute constructors against the content model of a complex type also registers the type of content expected of those constructors, so the static validation can continue recursively.
      Overrides:
        `checkPermittedContents` in class `Expression`
      Parameters:
        `parentType` - the "given complex type": the method is checking that the nodes returned by this expression are acceptable members of the content model of this type
        `whole` - if true, we want to check that the value of this expression satisfies the content model as a whole; if false we want to check that the value of the expression is acceptable as one part of the content
      Throws:
        `XPathException` - if the value delivered by this expression cannot be part of the content model of the given type

    - #### processLeavingTail

          public TailCall processLeavingTail​(Outputter output,
                                             XPathContext context)
                                      throws XPathException

      Description copied from class: `Instruction`
      ProcessLeavingTail: called to do the real work of this instruction. This method must be implemented in each subclass. The results of the instruction are written to the current Receiver, which can be obtained via the Controller.
      Specified by:
        `processLeavingTail` in interface `TailCallReturner`
      Specified by:
        `processLeavingTail` in class `Instruction`
      Parameters:
        `output` - the destination for the result
        `context` - The dynamic context of the transformation, giving access to the current node, the current variables, etc.
      Returns:
        null if the instruction has completed execution; or a TailCall indicating a function call or template call that is delegated to the caller, to be made after the stack has been unwound so as to save stack space.
      Throws:
        `XPathException` - if a dynamic error occurs during the evaluation of the instruction

    - #### makeSeparator

          protected NodeInfo makeSeparator​(XPathContext context)
                                    throws XPathException

      Throws:
        `XPathException`

    - #### iterate

          public SequenceIterator iterate​(XPathContext context)
                                   throws XPathException

      Return an Iterator to iterate over the values of the sequence.
      Overrides:
        `iterate` in class `Instruction`
      Parameters:
        `context` - supplies the context for evaluation
      Returns:
        a SequenceIterator that can be used to iterate over the result of the expression
      Throws:
        `XPathException` - if any dynamic error occurs evaluating the expression

    - #### map

          public SequenceIterator map​(XPathContext context)
                               throws XPathException

      Map one item to a sequence.
      Specified by:
        `map` in interface `ContextMappingFunction`
      Parameters:
        `context` - The processing context. The item to be mapped is the context item identified from this context: the values of position() and last() also relate to the set of items being mapped
      Returns:
        a SequenceIterator over the sequence of items that the supplied input item maps to
      Throws:
        `XPathException` - if a dynamic error is detected

    - #### evaluatePendingUpdates

          public void evaluatePendingUpdates​(XPathContext context,
                                             PendingUpdateList pul)
                                      throws XPathException

      Evaluate an updating expression, adding the results to a Pending Update List. The default implementation of this method, which is used for non-updating expressions, throws an UnsupportedOperationException
      Overrides:
        `evaluatePendingUpdates` in class `Expression`
      Parameters:
        `context` - the XPath dynamic evaluation context
        `pul` - the pending update list to which the results should be written
      Throws:
        `XPathException` - if evaluation fails
        `java.lang.UnsupportedOperationException` - if the expression is not an updating expression

    - #### export

          public void export​(ExpressionPresenter out)
                      throws XPathException

      Diagnostic print of expression structure. The abstract expression tree is written to the supplied output destination.
      Specified by:
        `export` in interface `ExportAgent`
      Specified by:
        `export` in class `Expression`
      Parameters:
        `out` - the expression presenter used to display the structure
      Throws:
        `XPathException` - if the export fails, for example if an expression is found that won't work in the target environment.

    - #### explainThreads

          protected void explainThreads​(ExpressionPresenter out)
                                 throws XPathException

      Throws:
        `XPathException`

    - #### toString

          public java.lang.String toString()

      The toString() method for an expression attempts to give a representation of the expression in an XPath-like form.

      For subclasses of Expression that represent XPath expressions, the result should always be a string that parses as an XPath 3.0 expression

      Overrides:
        `toString` in class `Expression`
      Returns:
        a representation of the expression as a string

    - #### toShortString

          public java.lang.String toShortString()

      Description copied from class: `Expression`
      Produce a short string identifying the expression for use in error messages
      Overrides:
        `toShortString` in class `Expression`
      Returns:
        a short string, sufficient to identify the expression

    - #### getExpressionName

          public java.lang.String getExpressionName()

      Get a name identifying the kind of expression, in terms meaningful to a user.
      Overrides:
        `getExpressionName` in class `Instruction`
      Returns:
        a name identifying the kind of expression, in terms meaningful to a user. The name will always be in the form of a lexical XML QName, and should match the name used in explain() output displaying the expression.

    - #### getStreamerName

          public java.lang.String getStreamerName()

      Get the (partial) name of a class that supports streaming of this kind of expression
      Overrides:
        `getStreamerName` in class `Expression`
      Returns:
        the partial name of a class that can be instantiated to provide streaming support in Saxon-EE, or null if there is no such class